﻿

Imports System.Reflection.Emit
Imports System.Runtime.Intrinsics.X86
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Security.Cryptography.Xml
Imports System.Security.Policy
Imports System.Windows
Imports System.Windows.Forms.VisualStyles.VisualStyleElement

Public Class Form1
    Public iChipMax As Integer = 4
    Public imgTemp(iChipMax) As Image
    Private imgTrans As New Bitmap("chip\\chip0.png")
    Public fMapScale As Single = 2
    Const CHIP_SIZE As Integer = 16
    Public Const CHIPDATMAX_X As Integer = 16
    Public Const CHIPDATMAX_Y As Integer = 16
    Public iMapDatX As Integer = 32
    Public iMapDatY As Integer = 32
    Public iRetryBuffMax As Integer = 100
    Public iCurrentRetryBuff As Integer
    Public iMatDat(iMapDatX, iMapDatY) As Point
    Public iMatDatBuff(iRetryBuffMax, iMapDatX, iMapDatY) As Point '元に戻すバッファ
    Public iMatDat_U(iMapDatX, iMapDatY) As Point
    Public iMatDat_UBuff(iRetryBuffMax, iMapDatX, iMapDatY) As Point '元に戻すバッファ
    Public iEvID(iMapDatX, iMapDatY) As Integer
    Public iEvIDBuff(iRetryBuffMax, iMapDatX, iMapDatY) As Integer '元に戻すバッファ
    Public iマップキャラID(iMapDatX, iMapDatY) As Integer
    Public iマップキャラIDBuff(iRetryBuffMax, iMapDatX, iMapDatY) As Integer '元に戻すバッファ
    Public picChipWinTapping As Boolean
    Public picMapWinTapping As Boolean
    Public selChip As Point
    Public selMap As Point
    Public pntMousePosPrev As Point 'マウス位置前回値
    Public pntMousePosFirst As Point 'マウス位置前回値
    Public iFillMode As Integer = 1
    Public iLayerMode As Integer
    Public iScaleMode As Integer
    Public sCurrentFile As String = "map\\default.txt"
    Public sCurrentChipDir As String = "chip\\chip"
    Public iChipID As Integer
    Public iChipDat(iChipMax, CHIPDATMAX_X, CHIPDATMAX_Y) As Integer
    Public iChipDatBuff(iRetryBuffMax, CHIPDATMAX_X, CHIPDATMAX_Y) As Integer '元に戻すバッファ
    Public fBaseScale As Integer = 64 / 16

    <Serializable()>
    Public Structure キャラデータ
        Public GDI_ID As Integer
        Public 画像 As Image
        Public Path As String
        Public サイズ As Point
        Public cxcy As Point
        Public iHitOffsetW As Integer
        Public iHitOffsetH As Integer
        Public AI As Integer
        Public MHP As Integer
        Public iEnemDeadAmin As Integer
        Public bEnemy As Boolean
        Public bLandingAble As Boolean
        Public bNoGravity As Boolean
        Public bThroughWall As Boolean
        Public bHitableOnlyMap As Boolean
        Public throughOK As Boolean
        Public bRideOK As Boolean
    End Structure

    Public 最大キャラ数 As Integer = 4
    Public キャラ画像ステータス(最大キャラ数) As キャラデータ

    Public Sub swapキャラデータ(idx1 As Integer, idx2 As Integer)
        Dim svデータ As キャラデータ = CommonUtil.ObjCopy(キャラ画像ステータス(idx1))

        キャラ画像ステータス(idx1) = CommonUtil.ObjCopy(キャラ画像ステータス(idx2))
        キャラ画像ステータス(idx2) = CommonUtil.ObjCopy(svデータ)
    End Sub
    Private Sub picChipWindow_Paint(sender As Object, e As PaintEventArgs) Handles picChipWindow.Paint

        Dim width As Integer
        Dim height As Integer
        width = CHIP_SIZE * 4
        height = CHIP_SIZE * 16
        Dim g As New Pen(Color.Blue, 3) '境界線用
        Dim tx As Integer
        Dim ty As Integer

        If iLayerMode = 3 Then
            tx = 1
            For i = 0 To 最大キャラ数 - 1
                '切り取る部分の範囲を決定する。
                Dim srcRect As New Rectangle(0, 0, キャラ画像ステータス(i).サイズ.X * fBaseScale - 1, キャラ画像ステータス(i).サイズ.Y * fBaseScale - 1)
                '描画する部分の範囲を決定する。
                Dim desRect As New Rectangle(tx * CHIP_SIZE * 2, ty * CHIP_SIZE * 2 - picChipWinScroll.Value, CHIP_SIZE * 2, CHIP_SIZE * 2)
                '画像の一部を描画する
                'g.DrawImage(img, desRect, srcRect, GraphicsUnit.Pixel)
                e.Graphics.DrawImage(キャラ画像ステータス(i).画像, desRect, srcRect, GraphicsUnit.Pixel)

                tx = tx + 1
                If tx > 3 Then
                    tx = 0
                    ty = ty + 1
                End If
            Next i
        Else
            For i = 0 To 3
                '切り取る部分の範囲を決定する。
                Dim srcRect As New Rectangle(i * width * fBaseScale, 0, width * fBaseScale - 1, height * fBaseScale - 1)
                '描画する部分の範囲を決定する。
                Dim desRect As New Rectangle(0, i * height * 2 - picChipWinScroll.Value, width * 2, height * 2)
                '画像の一部を描画する
                'g.DrawImage(img, desRect, srcRect, GraphicsUnit.Pixel)
                e.Graphics.DrawImage(imgTemp(iChipID), desRect, srcRect, GraphicsUnit.Pixel)

                '---height(256px)境界線
                e.Graphics.DrawRectangle(g, 0, (i + 1) * CHIP_SIZE * 16 * 2 - picChipWinScroll.Value, CHIP_SIZE * 4 * 2, 1)
            Next i
            g.Dispose()
        End If

        '---選択中のチップを囲む
        tx = pntMousePosFirst.X
        ty = pntMousePosFirst.Y

        While tx > (4 - 1)
            tx = tx - 4
            ty += 16
        End While

        Dim p As New Pen(Color.Red, 2)
        Dim q As New Pen(Color.Blue, 2)

        Dim tWidth = selChip.X - pntMousePosFirst.X + 1
        If tWidth <= 0 Then
            tWidth = 1
        End If

        Dim tHeight = selChip.Y - pntMousePosFirst.Y + 1
        If tHeight <= 0 Then
            tHeight = 1
        End If
        Dim tLeft = tx * CHIP_SIZE * 2
        Dim tTop = ty * CHIP_SIZE * 2 - picChipWinScroll.Value
        e.Graphics.DrawRectangle(p, tLeft, tTop, tWidth * CHIP_SIZE * 2, tHeight * CHIP_SIZE * 2)
        e.Graphics.DrawRectangle(q, tLeft + 2, tTop + 2, tWidth * CHIP_SIZE * 2, tHeight * CHIP_SIZE * 2)
        p.Dispose()
        q.Dispose()
    End Sub

    Private Sub picChipWinScroll_Scroll(sender As Object, e As ScrollEventArgs) Handles picChipWinScroll.Scroll
        picChipWindow.Invalidate()
    End Sub
    Private Sub picChipWindow_MouseWheel(sender As Object, e As MouseEventArgs) Handles picChipWindow.MouseWheel
        Dim a As Integer = picChipWinScroll.Value - e.Delta
        If a < 0 Then
            a = 0
        ElseIf a > picChipWinScroll.Maximum Then
            a = picChipWinScroll.Maximum
        End If

        picChipWinScroll.Value = a
        picChipWindow.Invalidate()
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.Text = "マップメーカー　version 1.03　(c)Nengasoft 2023"
        LoadChipData(sCurrentChipDir)
        picChipWinScroll.Maximum = CHIP_SIZE * 16 * 4 * 2 - picChipWindow.Height + 16
        fBaseScale = (imgTemp(0).Width / 16) / 16 '64/16
        fixBuffSize()
        imgTrans.MakeTransparent(imgTrans.GetPixel(0, 0))
        statusLabel.Text = "Ready."
        fixScrollBarSize()


        Loadキャラデータ()

    End Sub

    Private Sub picMapWindow_Paint(sender As Object, e As PaintEventArgs) Handles picMapWindow.Paint
        Dim width As Integer
        Dim height As Integer
        width = CHIP_SIZE * fMapScale
        height = CHIP_SIZE * fMapScale
        Dim dx As Integer
        Dim dy As Integer

        '下マップ
        For y = 0 To iMapDatY - 1
            For x = 0 To iMapDatX - 1

                'クリッピング
                dx = x * width - picMapWinScroll_H.Value
                dy = y * height - picMapWinScroll_V.Value
                If dx + width < 0 Or dx > picMapWindow.Width Or
                dy + height < 0 Or dy > picMapWindow.Height Then
                    Continue For
                End If

                '切り取る部分の範囲を決定する。
                Dim srcRect As New Rectangle(iMatDat(x, y).X * CHIP_SIZE * fBaseScale, iMatDat(x, y).Y * CHIP_SIZE * fBaseScale, CHIP_SIZE * fBaseScale - 1, CHIP_SIZE * fBaseScale - 1)
                '描画する部分の範囲を決定する。
                Dim desRect As New Rectangle(dx, dy, width, height)
                '画像の一部を描画する
                e.Graphics.DrawImage(imgTemp(iChipID), desRect, srcRect, GraphicsUnit.Pixel)
            Next x
        Next y

        '上マップ
        If iLayerMode = 1 Then
            '半透明黒で塗りつぶし
            Dim b As New SolidBrush(Color.FromArgb(100, 200, 50, 100))
            e.Graphics.FillRectangle(b, 0, 0, picMapWindow.Width, picMapWindow.Height)
            b.Dispose()

            For y = 0 To iMapDatY - 1
                For x = 0 To iMapDatX - 1

                    'クリッピング
                    dx = x * width - picMapWinScroll_H.Value
                    dy = y * height - picMapWinScroll_V.Value
                    If dx + width < 0 Or dx > picMapWindow.Width Or
                        dy + height < 0 Or dy > picMapWindow.Height Then
                        Continue For
                    End If

                    If iMatDat_U(x, y).X <> 0 Or iMatDat_U(x, y).Y <> 0 Then
                        '切り取る部分の範囲を決定する。
                        Dim srcRect As New Rectangle(iMatDat_U(x, y).X * CHIP_SIZE * fBaseScale, iMatDat_U(x, y).Y * CHIP_SIZE * fBaseScale, CHIP_SIZE * fBaseScale - 1, CHIP_SIZE * fBaseScale - 1)
                        '描画する部分の範囲を決定する。
                        Dim desRect As New Rectangle(dx, dy, width, height)
                        '画像の一部を描画する
                        e.Graphics.DrawImage(imgTrans, desRect, srcRect, GraphicsUnit.Pixel)
                    End If
                Next x
            Next y
        Else
            'ColorMatrixオブジェクトの作成
            Dim cm As New System.Drawing.Imaging.ColorMatrix()
            'ColorMatrixの行列の値を変更して、アルファ値が0.5に変更されるようにする
            cm.Matrix00 = 1
            cm.Matrix11 = 1
            cm.Matrix22 = 1
            cm.Matrix33 = 0.5F
            cm.Matrix44 = 1

            'ImageAttributesオブジェクトの作成
            Dim ia As New System.Drawing.Imaging.ImageAttributes()
            'ColorMatrixを設定する
            ia.SetColorMatrix(cm)

            '↓ImageAttributesを使用して画像を描画

            For y = 0 To iMapDatY - 1 'picMapWindow.Height / height 'iMapDatY - 1
                For x = 0 To iMapDatX - 1 'picMapWindow.Width / width 'width - 1

                    'クリッピング
                    dx = x * width - picMapWinScroll_H.Value
                    dy = y * height - picMapWinScroll_V.Value
                    If dx + width < 0 Or dx > picMapWindow.Width Or
                        dy + height < 0 Or dy > picMapWindow.Height Then
                        Continue For
                    End If

                    If iMatDat_U(x, y).X <> 0 Or iMatDat_U(x, y).Y <> 0 Then
                        '切り取る部分の範囲を決定する。
                        Dim srcRect As New Rectangle(iMatDat_U(x, y).X * CHIP_SIZE * fBaseScale, iMatDat_U(x, y).Y * CHIP_SIZE * fBaseScale, CHIP_SIZE * fBaseScale - 1, CHIP_SIZE * fBaseScale - 1)
                        '描画する部分の範囲を決定する。
                        Dim desRect As New Rectangle(dx, dy, width, height)
                        '画像の一部を描画する
                        e.Graphics.DrawImage(imgTrans, desRect,
                                             srcRect.Left, srcRect.Top, srcRect.Right - srcRect.Left, srcRect.Bottom - srcRect.Top,
                                             GraphicsUnit.Pixel, ia)
                    End If
                Next x
            Next y
        End If


        If iLayerMode = 2 Then
            '半透明黒で塗りつぶし
            Dim b As New SolidBrush(Color.FromArgb(100, 200, 50, 100))
            e.Graphics.FillRectangle(b, 0, 0, picMapWindow.Width, picMapWindow.Height)
            b.Dispose()

            'フォントオブジェクトの作成
            Dim fnt As New Font("MS UI Gothic", 10 * fMapScale)
            For y = 0 To iMapDatY - 1 'picMapWindow.Height / height 'iMapDatY - 1
                For x = 0 To iMapDatX - 1 'picMapWindow.Width / width 'width - 1
                    If iEvID(x, y) <> 0 Then
                        e.Graphics.DrawString(iEvID(x, y), fnt, Brushes.White, x * width - picMapWinScroll_H.Value, y * height - picMapWinScroll_V.Value)
                    End If
                Next x
            Next y
        End If



        If iLayerMode = 3 Then 'キャラ
            '半透明黒で塗りつぶし
            Dim b As New SolidBrush(Color.FromArgb(100, 200, 50, 100))
            e.Graphics.FillRectangle(b, 0, 0, picMapWindow.Width, picMapWindow.Height)
            b.Dispose()

        End If

        If True Then
            Dim NUM As Integer
            width = 16 * fMapScale
            height = 16 * fMapScale

            'フォントオブジェクトの作成
            Dim fnt As New Font("MS UI Gothic", 10 * fMapScale)

            For y = 0 To iMapDatY - 1 'picMapWindow.Height / height 'iMapDatY - 1
                For x = 0 To iMapDatX - 1 'picMapWindow.Width / width 'width - 1


                    If iマップキャラID(x, y) <> 0 Then
                        NUM = iマップキャラID(x, y) - 1

                        'クリッピング
                        dx = x * width - picMapWinScroll_H.Value
                        dy = y * height - picMapWinScroll_V.Value
                        If dx + width < 0 Or dx > picMapWindow.Width Or
                        dy + height < 0 Or dy > picMapWindow.Height Then
                            Continue For
                        End If

                        e.Graphics.DrawString("💩", fnt, Brushes.White, x * width - picMapWinScroll_H.Value, y * height - picMapWinScroll_V.Value)

                        '切り取る部分の範囲を決定する。
                        'Dim srcRect As New Rectangle(0, 0, キャラ画像ステータス(NUM).サイズ.X * fBaseScale - 1, キャラ画像ステータス(NUM).サイズ.Y * fBaseScale - 1)
                        '描画する部分の範囲を決定する。
                        'Dim desRect As New Rectangle(dx, dy, width, height)
                        '画像の一部を描画する
                        'e.Graphics.DrawImage(キャラ画像ステータス(NUM).画像, desRect, srcRect, GraphicsUnit.Pixel)

                        '切り取る部分の範囲を決定する。
                        Dim srcRect As New Rectangle(0, 0, キャラ画像ステータス(NUM).サイズ.X - 1, キャラ画像ステータス(NUM).サイズ.Y - 1)
                        '描画する部分の範囲を決定する。
                        Dim desRect As New Rectangle(dx, dy, width, height)
                        '画像の一部を描画する
                        e.Graphics.DrawImage(キャラ画像ステータス(NUM).画像, desRect, srcRect, GraphicsUnit.Pixel)
                    End If
                Next x
            Next y
        End If

    End Sub

    Private Sub picChipWindow_MouseDown(sender As Object, e As MouseEventArgs) Handles picChipWindow.MouseDown
        picChipWinTapping = True
        picChipWin_Sel()

        '初回クリック位置
        pntMousePosFirst.X = selChip.X
        pntMousePosFirst.Y = selChip.Y
    End Sub

    Private Sub picChipWindow_MouseMove(sender As Object, e As MouseEventArgs) Handles picChipWindow.MouseMove
        If picChipWinTapping Then
            picChipWin_Sel()

            Dim temp As Integer
            If pntMousePosFirst.X > selChip.X Then
                temp = pntMousePosFirst.X
                pntMousePosFirst.X = selChip.X
                selChip.X = temp
            End If
            'If selChip.X > 3 Then
            'selChip.X = 3
            'End If

            If pntMousePosFirst.Y > selChip.Y Then
                temp = pntMousePosFirst.Y
                pntMousePosFirst.Y = selChip.Y
                selChip.Y = temp
            End If
        End If
    End Sub

    Private Sub picChipWindow_MouseUp(sender As Object, e As MouseEventArgs) Handles picChipWindow.MouseUp
        picChipWinTapping = False
    End Sub
    Private Sub picChipWindow_MouseLeave(sender As Object, e As EventArgs) Handles picChipWindow.MouseLeave
        picChipWinTapping = False
    End Sub

    Private Sub picChipWin_Sel()
        Dim Pos As Point = picChipWindow.PointToClient(Windows.Forms.Cursor.Position)
        Dim tx As Integer = Pos.X
        Dim ty As Integer = Pos.Y + picChipWinScroll.Value

        If tx < 0 Then
            tx = 0
        ElseIf tx > CHIP_SIZE * 3.5 * 2 Then
            tx = CHIP_SIZE * 3.5 * 2
        End If

        If ty < 0 Then
            ty = 0
        ElseIf ty > CHIP_SIZE * 4 * 16 * 2 Then
            ty = CHIP_SIZE * 4 * 16 * 2
        End If
        While ty > CHIP_SIZE * 16 * 2
            ty = ty - CHIP_SIZE * 16 * 2
            tx += CHIP_SIZE * 4 * 2
        End While
        selChip.X = (tx - CHIP_SIZE) / (CHIP_SIZE * 2)
        selChip.Y = (ty - CHIP_SIZE) / (CHIP_SIZE * 2)

        'MsgBox(selChip.X & "," & selChip.Y)
        picChipWindow.Invalidate()
    End Sub

    Private Sub picMapWindow_MouseDown(sender As Object, e As MouseEventArgs) Handles picMapWindow.MouseDown
        picMapWinTapping = True
        picMapWin_Sel()

        'マウス位置前回値
        pntMousePosPrev.X = selMap.X
        pntMousePosPrev.Y = selMap.Y

        If iFillMode = 1 Or iFillMode = 2 Then
            picMapWin_Write(selMap.X, selMap.Y, selChip.X - pntMousePosFirst.X, selChip.Y - pntMousePosFirst.Y, pntMousePosFirst)
            picMapWindow.Invalidate()
        ElseIf iFillMode = 3 Then
            Dim tp As Point
            tp.X = iMatDat(selMap.X, selMap.Y).X
            tp.Y = iMatDat(selMap.X, selMap.Y).Y
            picMapWin_Fill(selMap.X, selMap.Y, pntMousePosFirst, tp)
            picMapWindow.Invalidate()
        End If

    End Sub

    Private Sub picMapWindow_MouseMove(sender As Object, e As MouseEventArgs) Handles picMapWindow.MouseMove
        If picMapWinTapping Then
            picMapWin_Sel()
            Dim iComplement As Integer = 256
            Dim i As Integer
            Dim ax As Single = (selMap.X - pntMousePosPrev.X) / CType(iComplement, Single)
            Dim ay As Single = (selMap.Y - pntMousePosPrev.Y) / CType(iComplement, Single)

            Dim tx As Integer
            Dim ty As Integer
            Dim tx_prev As Integer = -999
            Dim ty_prev As Integer = -999

            If iFillMode = 1 Then
                '補完しつつ描画
                For i = 0 To (iComplement + 1)
                    tx = pntMousePosPrev.X + ax * i
                    ty = pntMousePosPrev.Y + ay * i
                    If tx <> tx_prev Or ty <> ty_prev Then
                        picMapWin_Write(tx, ty, selChip.X - pntMousePosFirst.X, selChip.Y - pntMousePosFirst.Y, pntMousePosFirst)
                    End If
                    tx_prev = tx
                    ty_prev = ty
                Next i
                picMapWindow.Invalidate()

                'マウス位置前回値
                pntMousePosPrev.X = selMap.X
                pntMousePosPrev.Y = selMap.Y

            ElseIf iFillMode = 2 Then '矩形モード
                Dim width = selMap.X - pntMousePosPrev.X
                Dim height = selMap.Y - pntMousePosPrev.Y
                Dim x As Integer
                Dim y As Integer
                Dim stx As Integer = pntMousePosPrev.X
                Dim sty As Integer = pntMousePosPrev.Y

                If width < 1 Then
                    stx = selMap.X
                    width = -width
                End If
                If height < 1 Then
                    sty = selMap.Y
                    height = -height
                End If

                For y = 0 To height
                    For x = 0 To width
                        picMapWin_Write(stx + x, sty + y, selChip.X - pntMousePosFirst.X, selChip.Y - pntMousePosFirst.Y, pntMousePosFirst)
                    Next x
                Next y
                picMapWindow.Invalidate()
            End If
        End If

        statusLabel.Text = selMap.X & "," & selMap.Y
    End Sub

    Private Sub picMapWindow_MouseUp(sender As Object, e As MouseEventArgs) Handles picMapWindow.MouseUp
        picMapWinTapping = False
        write_iMatDatBuff() 'バッファに保存
    End Sub
    Private Sub picMapWindow_MouseLeave(sender As Object, e As EventArgs) Handles picMapWindow.MouseLeave
        picMapWinTapping = False
    End Sub

    Private Sub picMapWin_Sel()
        Dim Pos As Point = picMapWindow.PointToClient(Windows.Forms.Cursor.Position)
        Dim tx As Integer = Pos.X + picMapWinScroll_H.Value - CHIP_SIZE * fMapScale / 2
        Dim ty As Integer = Pos.Y + picMapWinScroll_V.Value - CHIP_SIZE * fMapScale / 2

        selMap.X = tx / (CHIP_SIZE * fMapScale)
        selMap.Y = ty / (CHIP_SIZE * fMapScale)

        If selMap.X < 0 Then
            selMap.X = 0
        ElseIf selMap.X > iMapDatX - 1 Then
            selMap.X = iMapDatX - 1
        End If

        If selMap.Y < 0 Then
            selMap.Y = 0
        ElseIf selMap.Y > iMapDatY - 1 Then
            selMap.Y = iMapDatY - 1
        End If
        'MsgBox(selMap_X & "," & selMap_Y)

    End Sub
    Private Sub picMapWin_Write(wx As Integer, wy As Integer, width As Integer, height As Integer, chip As Point)
        'iMatDat(wx, wy).X = chip.X
        'iMatDat(wx, wy).Y = chip.Y

        If wx < 0 Then
            wx = 0
        ElseIf wx > iMapDatX - 1 Then
            wx = iMapDatX - 1
        End If
        If wy < 0 Then
            wy = 0
        ElseIf wy > iMapDatY - 1 Then
            wy = iMapDatY - 1
        End If

        Dim x As Integer
        Dim y As Integer
        For y = 0 To height
            For x = 0 To width
                Dim tx As Integer = wx + x
                Dim ty As Integer = wy + y
                If tx >= iMapDatX Or ty >= iMapDatY Then
                    Exit For
                End If

                Select Case iLayerMode
                    Case 0
                        iMatDat(tx, ty).X = chip.X + x
                        iMatDat(tx, ty).Y = chip.Y + y
                    Case 1
                        iMatDat_U(tx, ty).X = chip.X + x
                        iMatDat_U(tx, ty).Y = chip.Y + y
                    Case 2
                        iEvID(tx, ty) = Integer.Parse(txtEvID.Text)
                    Case 3
                        iマップキャラID(tx, ty) = (chip.X Mod 4) + chip.Y * 4
                End Select

            Next x
        Next y

    End Sub
    Private Sub picMapWin_Fill(x As Integer, y As Integer, col As Point, prevCol As Point)

        If x < 0 Or y < 0 Or x >= iMapDatX Or y >= iMapDatY Then
            Exit Sub
        End If

        If iMatDat(x, y) <> prevCol Then
            Exit Sub
        End If

        If iMatDat(x, y) = col Then
            Exit Sub
        End If
        iMatDat(x, y) = col

        picMapWin_Fill(x, y + 1, col, prevCol)
        picMapWin_Fill(x - 1, y, col, prevCol)
        picMapWin_Fill(x, y - 1, col, prevCol)
        picMapWin_Fill(x + 1, y, col, prevCol)


    End Sub

    Private Sub picMapWinScroll_V_Scroll(sender As Object, e As ScrollEventArgs) Handles picMapWinScroll_V.Scroll
        picMapWindow.Invalidate()
    End Sub
    Private Sub picMapWindow_MouseWheel(sender As Object, e As MouseEventArgs) Handles picMapWindow.MouseWheel
        Dim a As Integer = picMapWinScroll_V.Value - e.Delta
        If a < 0 Then
            a = 0
        ElseIf a > picMapWinScroll_V.Maximum Then
            a = picMapWinScroll_V.Maximum
        End If

        picMapWinScroll_V.Value = a
        picMapWindow.Invalidate()
    End Sub

    Private Sub picMapWinScroll_H_Scroll(sender As Object, e As ScrollEventArgs) Handles picMapWinScroll_H.Scroll
        picMapWindow.Invalidate()
        statusLabel.Text = picMapWinScroll_H.Value
    End Sub

    Private Sub btnFillMode0_Click(sender As Object, e As EventArgs) Handles btnFillMode0.Click
        iFillMode = 0
        lblFillMode.Left = btnFillMode0.Left
        statusLabel.Text = picMapWinScroll_V.Value
    End Sub

    Private Sub btnFillMode1_Click(sender As Object, e As EventArgs) Handles btnFillMode1.Click
        iFillMode = 1
        lblFillMode.Left = btnFillMode1.Left
    End Sub

    Private Sub btnFillMode2_Click(sender As Object, e As EventArgs) Handles btnFillMode2.Click
        iFillMode = 2
        lblFillMode.Left = btnFillMode2.Left
    End Sub

    Private Sub btnFillMode3_Click(sender As Object, e As EventArgs) Handles btnFillMode3.Click
        iFillMode = 3
        lblFillMode.Left = btnFillMode3.Left
        MsgBox("この機能は開発中のもので、あまり大きいマップで実行すると落ちるからヨロシク！" & vbCrLf & "もし使う場合、念のためデータを保存してください。")
    End Sub

    Private Sub btnLayerMode0_Click(sender As Object, e As EventArgs) Handles btnLayerMode0.Click
        iLayerMode = 0
        lblLayerMode.Left = btnLayerMode0.Left
        picMapWindow.Invalidate()
        picChipWindow.Invalidate()
    End Sub

    Private Sub btnLayerMode1_Click(sender As Object, e As EventArgs) Handles btnLayerMode1.Click
        iLayerMode = 1
        lblLayerMode.Left = btnLayerMode1.Left
        picMapWindow.Invalidate()
        picChipWindow.Invalidate()
    End Sub

    Private Sub btnLayerMode2_Click(sender As Object, e As EventArgs) Handles btnLayerMode2.Click
        iLayerMode = 2
        lblLayerMode.Left = btnLayerMode2.Left
        picMapWindow.Invalidate()
    End Sub

    Private Sub btnLayerMode3_Click(sender As Object, e As EventArgs) Handles btnLayerMode3.Click
        iLayerMode = 3
        lblLayerMode.Left = btnLayerMode3.Left
        picMapWindow.Invalidate()
        picChipWindow.Invalidate()
    End Sub

    Private Sub write_iMatDatBuff()

        iCurrentRetryBuff = iCurrentRetryBuff + 1
        If iCurrentRetryBuff >= iRetryBuffMax Then
            iCurrentRetryBuff = 0
        End If

        Dim x As Integer
        Dim y As Integer
        For y = 0 To iMapDatY - 1
            For x = 0 To iMapDatX - 1
                iMatDatBuff(iCurrentRetryBuff, x, y) = iMatDat(x, y)
                iMatDat_UBuff(iCurrentRetryBuff, x, y) = iMatDat_U(x, y)
                iEvIDBuff(iCurrentRetryBuff, x, y) = iEvID(x, y)
                iマップキャラIDBuff(iCurrentRetryBuff, x, y) = iマップキャラID(x, y)
            Next x
        Next y
    End Sub
    Private Sub Read_iMatDatBuff(iDirection As Integer)

        iCurrentRetryBuff = iCurrentRetryBuff + iDirection
        If iCurrentRetryBuff < 0 Then
            iCurrentRetryBuff = iRetryBuffMax + iDirection
        ElseIf iCurrentRetryBuff >= iRetryBuffMax Then
            iCurrentRetryBuff = 0
        End If

        Dim x As Integer
        Dim y As Integer
        For y = 0 To iMapDatY - 1
            For x = 0 To iMapDatX - 1
                iMatDat(x, y) = iMatDatBuff(iCurrentRetryBuff, x, y)
                iMatDat_U(x, y) = iMatDat_UBuff(iCurrentRetryBuff, x, y)
                iEvID(x, y) = iEvIDBuff(iCurrentRetryBuff, x, y)
                iマップキャラID(x, y) = iマップキャラIDBuff(iCurrentRetryBuff, x, y)
            Next x
        Next y

        picMapWindow.Invalidate()

        statusLabel.Text = "元戻し完了。iCurrentRetryBuff=" & iCurrentRetryBuff
    End Sub

    Private Sub 元に戻すToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 元に戻すToolStripMenuItem.Click
        Read_iMatDatBuff(-1)
    End Sub
    Private Sub やりなおしToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles やりなおしToolStripMenuItem.Click
        Read_iMatDatBuff(+1)
    End Sub

    Private Sub saveFiles()
        saveMapData()
        saveMapData_BMP()
        Saveキャラデータ()
        Saveキャラデータ用JSソースファイル()
        statusLabel.Text = "ファイルを保存しました。" & sCurrentFile & " " & Date.Now
    End Sub
    Private Sub 上書き保存ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 上書き保存ToolStripMenuItem.Click
        saveFiles()
    End Sub
    Private Sub saveMapData()
        '書き込むファイルが既に存在している場合は、上書きする
        Dim sw As New System.IO.StreamWriter(sCurrentFile, False, System.Text.Encoding.GetEncoding("UTF-8"))

        sw.Write(iChipID & vbCrLf)
        sw.Write(iMapDatX & vbCrLf)
        sw.Write(iMapDatY & vbCrLf)

        Dim x As Integer
        Dim y As Integer
        For y = 0 To iMapDatY - 1
            For x = 0 To iMapDatX - 1
                sw.Write(iMatDat(x, y).X & vbCrLf & iMatDat(x, y).Y & vbCrLf)
            Next x
        Next y

        For y = 0 To iMapDatY - 1
            For x = 0 To iMapDatX - 1
                sw.Write(iMatDat_U(x, y).X & vbCrLf & iMatDat_U(x, y).Y & vbCrLf)
            Next x
        Next y

        For y = 0 To iMapDatY - 1
            For x = 0 To iMapDatX - 1
                sw.Write(iEvID(x, y) & vbCrLf)
            Next x
        Next y

        For y = 0 To iMapDatY - 1
            For x = 0 To iMapDatX - 1
                sw.Write(iマップキャラID(x, y) & vbCrLf)
            Next x
        Next y

        '閉じる
        sw.Close()
    End Sub
    Private Sub saveMapData_BMP()
        Dim img = New Bitmap(iMapDatX, iMapDatY * 2 + 1) '最後の行はチップセットIDとか入れる。ｘが変動するのでデータ数注意！

        For y = 0 To iMapDatY - 1
            For x = 0 To iMapDatX - 1
                Dim c As Color = Color.FromArgb(
                    iEvID(x, y),'r evID
                    iMatDat_U(x, y).Y * 16 + iMatDat_U(x, y).X,'g 上マップ
                    iMatDat(x, y).Y * 16 + iMatDat(x, y).X) 'b 下マップ


                img.SetPixel(x, y, c)
            Next x
        Next y

        Dim マップキャラデータ As Integer
        For y = iMapDatY To iMapDatY * 2 - 1
            For x = 0 To iMapDatX - 1
                マップキャラデータ = iマップキャラID(x, y - iMapDatY)

                If マップキャラデータ <> 0 Then
                    Dim temp As Integer
                    temp = 5
                End If
                Dim c As Color = Color.FromArgb(
                    0,
                    マップキャラデータ >> 16,
                    マップキャラデータ And &HFFFF) 'b

                img.SetPixel(x, y, c)
            Next x
        Next y

        img.SetPixel(0, iMapDatY * 2, Color.FromArgb(
                    iChipID,'r iChipID 
                    0, 'g 
                    0)) 'b

        '保存
        img.Save(sCurrentFile & ".png", Imaging.ImageFormat.Png)


    End Sub

    Private Sub Saveキャラデータ()
        '書き込むファイルが既に存在している場合は、上書きする
        Dim sw As New System.IO.StreamWriter("chara\\キャラのデータ.txt", False, System.Text.Encoding.GetEncoding("UTF-8"))

        sw.Write(最大キャラ数 & vbCrLf)

        Dim i As Integer
        For i = 0 To 最大キャラ数 - 1
            sw.Write((i + 1) & vbCrLf)
            sw.Write(キャラ画像ステータス(i).GDI_ID & vbCrLf)
            sw.Write(キャラ画像ステータス(i).Path & vbCrLf)
            sw.Write(キャラ画像ステータス(i).サイズ.X & vbCrLf)
            sw.Write(キャラ画像ステータス(i).サイズ.Y & vbCrLf)
            sw.Write(キャラ画像ステータス(i).cxcy.X & vbCrLf)
            sw.Write(キャラ画像ステータス(i).cxcy.Y & vbCrLf)
            sw.Write(キャラ画像ステータス(i).iHitOffsetW & vbCrLf)
            sw.Write(キャラ画像ステータス(i).iHitOffsetH & vbCrLf)
            sw.Write(キャラ画像ステータス(i).AI & vbCrLf)
            sw.Write(キャラ画像ステータス(i).MHP & vbCrLf)
            sw.Write(キャラ画像ステータス(i).iEnemDeadAmin & vbCrLf)
            sw.Write(キャラ画像ステータス(i).bEnemy & vbCrLf)
            sw.Write(キャラ画像ステータス(i).bLandingAble & vbCrLf)
            sw.Write(キャラ画像ステータス(i).bNoGravity & vbCrLf)
            sw.Write(キャラ画像ステータス(i).bThroughWall & vbCrLf)
            sw.Write(キャラ画像ステータス(i).bHitableOnlyMap & vbCrLf)
            sw.Write(キャラ画像ステータス(i).throughOK & vbCrLf)
            sw.Write(キャラ画像ステータス(i).bRideOK & vbCrLf)
        Next i

        '閉じる
        sw.Close()
    End Sub
    Public Function jsのBOOLEANに変換(bool As Boolean)
        If Not bool Then
            Return "false"
        End If
        Return "true"
    End Function
    Private Sub Saveキャラデータ用JSソースファイル()

        Dim sヘッダー As String
        Dim sフッター As String
        Dim s As String
        Dim sr As New System.IO.StreamReader("chara\\src\\header.txt", System.Text.Encoding.GetEncoding("UTF-8"))
        sヘッダー = sr.ReadLine()
        Do While Not sr.EndOfStream
            sヘッダー = sヘッダー & sr.ReadLine() & vbCrLf
        Loop
        sr.Close()

        sr = New System.IO.StreamReader("chara\\src\\footer.txt", System.Text.Encoding.GetEncoding("UTF-8"))
        sフッター = sr.ReadLine()
        Do While Not sr.EndOfStream
            sフッター = sフッター & sr.ReadLine() & vbCrLf
        Loop
        sr.Close()


        '書き込むファイルが既に存在している場合は、上書きする
        Dim sw As New System.IO.StreamWriter("chara\\src\\loadCharaST.js", False, System.Text.Encoding.GetEncoding("UTF-8"))

        sw.Write(sヘッダー & vbCrLf)
        sw.Write(vbTab & "switch(ID){" & vbCrLf)

        Dim i As Integer
        Dim sタブ1 As String = vbTab & vbTab
        Dim sタブ2 As String = vbTab & vbTab & vbTab
        For i = 0 To 最大キャラ数 - 1
            sw.Write(sタブ1 & "case " & (i + 1) & "://" & キャラ画像ステータス(i).Path & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].putForFld(" & キャラ画像ステータス(i).GDI_ID & ",x,y,0,0);" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].w = " & キャラ画像ステータス(i).サイズ.X & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].h = " & キャラ画像ステータス(i).サイズ.Y & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].iHitOffsetW = " & キャラ画像ステータス(i).iHitOffsetW & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].iHitOffsetH = " & キャラ画像ステータス(i).iHitOffsetH & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].AI.setAI(NUM," & キャラ画像ステータス(i).AI & ");" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].MHP = " & キャラ画像ステータス(i).MHP & "; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].cx = " & キャラ画像ステータス(i).cxcy.X & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].cy = " & キャラ画像ステータス(i).cxcy.Y & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].iEnemDeadAmin = " & キャラ画像ステータス(i).iEnemDeadAmin & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].bEnemy = " & jsのBOOLEANに変換(キャラ画像ステータス(i).bEnemy) & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].bLandingAble = " & jsのBOOLEANに変換(キャラ画像ステータス(i).bLandingAble) & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].bNoGravity = " & jsのBOOLEANに変換(キャラ画像ステータス(i).bNoGravity) & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].bThroughWall = " & jsのBOOLEANに変換(キャラ画像ステータス(i).bThroughWall) & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].bHitableOnlyMap = " & jsのBOOLEANに変換(キャラ画像ステータス(i).bHitableOnlyMap) & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].throughOK = " & jsのBOOLEANに変換(キャラ画像ステータス(i).throughOK) & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].bHitableOnlyMap = " & jsのBOOLEANに変換(キャラ画像ステータス(i).bHitableOnlyMap) & ";" & vbCrLf)
            sw.Write(sタブ2 & "pMode.chara[NUM].bRideOK = " & jsのBOOLEANに変換(キャラ画像ステータス(i).bRideOK) & ";" & vbCrLf)
            sw.Write(sタブ1 & "break;" & vbCrLf)
        Next i

        sw.Write(sフッター & vbCrLf)
        '閉じる
        sw.Close()
    End Sub

    Public Sub saveChipData()
        Dim k As Integer
        For k = 0 To iChipMax - 1
            '書き込むファイルが既に存在している場合は、上書きする
            Dim sw As New System.IO.StreamWriter(sCurrentChipDir & k & ".txt", False, System.Text.Encoding.GetEncoding("UTF-8"))

            'sw.Write(CHIPDATMAX_X & vbCrLf)
            'sw.Write(CHIPDATMAX_Y & vbCrLf)

            Dim x As Integer
            Dim y As Integer
            For y = 0 To CHIPDATMAX_Y - 1
                For x = 0 To CHIPDATMAX_X - 1
                    sw.Write(iChipDat(k, x, y) & vbCrLf)
                Next x
            Next y

            '閉じる
            sw.Close()
        Next k
    End Sub
    Public Sub saveChipData_BMP()
        Dim k As Integer
        For k = 0 To iChipMax - 1
            Dim img = New Bitmap(CHIPDATMAX_Y, CHIPDATMAX_Y)

            For y = 0 To CHIPDATMAX_Y - 1
                For x = 0 To CHIPDATMAX_Y - 1
                    Dim c As Color = Color.FromArgb(
                        0,'r 
                        (iChipDat(k, x, y) >> 8) And &HFF,'g 
                        (iChipDat(k, x, y)) And &HFF) 'b 
                    img.SetPixel(x, y, c)
                Next x
            Next y

            '保存
            img.Save(sCurrentChipDir & k & ".txt.png", Imaging.ImageFormat.Png)
        Next k
    End Sub

    Private Sub fixBuffSize()
        ReDim iMatDat(iMapDatX, iMapDatY)
        ReDim iMatDatBuff(iRetryBuffMax, iMapDatX, iMapDatY)
        ReDim iMatDat_U(iMapDatX, iMapDatY)
        ReDim iMatDat_UBuff(iRetryBuffMax, iMapDatX, iMapDatY)
        ReDim iEvID(iMapDatX, iMapDatY)
        ReDim iEvIDBuff(iRetryBuffMax, iMapDatX, iMapDatY)
        ReDim iマップキャラID(iMapDatX, iMapDatY)
        ReDim iマップキャラIDBuff(iRetryBuffMax, iMapDatX, iMapDatY)

        fixScrollBarSize()
    End Sub
    Private Sub fixScrollBarSize()
        picMapWinScroll_H.Maximum = CHIP_SIZE * fMapScale * iMapDatX + 16 - picMapWindow.Width
        picMapWinScroll_H.Minimum = 0
        picMapWinScroll_V.Maximum = CHIP_SIZE * fMapScale * iMapDatY + 16 - picMapWindow.Height
        picMapWinScroll_V.Minimum = 0
    End Sub
    Private Sub LoadMapData()

        statusLabel.Text = "ファイルを読み込み中・・・"

        'OpenFileDialogクラスのインスタンスを作成
        Dim ofd As New OpenFileDialog()

        'はじめのファイル名を指定する
        'はじめに「ファイル名」で表示される文字列を指定する
        ofd.FileName = "default.txt"
        'はじめに表示されるフォルダを指定する
        '指定しない（空の文字列）の時は、現在のディレクトリが表示される
        ofd.InitialDirectory = System.Environment.CurrentDirectory & "\map\"
        '[ファイルの種類]に表示される選択肢を指定する
        '指定しないとすべてのファイルが表示される
        ofd.Filter = "テキストファイル(*.txt)|*.txt|すべてのファイル(*.*)|*.*"
        '[ファイルの種類]ではじめに選択されるものを指定する
        '2番目の「すべてのファイル」が選択されているようにする
        ofd.FilterIndex = 1
        'タイトルを設定する
        ofd.Title = "マップファイルを開く"
        'ダイアログボックスを閉じる前に現在のディレクトリを復元するようにする
        ofd.RestoreDirectory = True

        'ダイアログを表示する
        If ofd.ShowDialog() = DialogResult.OK Then
            'OKボタンがクリックされたとき、選択されたファイル名を表示する
            sCurrentFile = ofd.FileName

            Dim sr As New System.IO.StreamReader(sCurrentFile, System.Text.Encoding.GetEncoding("UTF-8"))

            Dim s As String

            '１行読み込む
            s = sr.ReadLine()
            iChipID = Integer.Parse(s)
            sCurrentChipDir = "chip\\chip"

            '１行読み込む
            s = sr.ReadLine()
            iMapDatX = Integer.Parse(s)

            '１行読み込む
            s = sr.ReadLine()
            iMapDatY = Integer.Parse(s)

            '配列サイズを変更
            fixBuffSize()

            Dim num As Integer
            Dim delimiter As String = ","
            Dim parts As String()

            '１行読み込む
            's = sr.ReadLine()
            'parts = Split(s, delimiter, -1, CompareMethod.Text)
            For y = 0 To iMapDatY - 1
                For x = 0 To iMapDatX - 1
                    'iMatDat(x, y).X = Integer.Parse(parts(num))
                    'iMatDat(x, y).Y = Integer.Parse(parts(num + 1))
                    'num = num + 2
                    s = sr.ReadLine()
                    iMatDat(x, y).X = Integer.Parse(s)
                    s = sr.ReadLine()
                    iMatDat(x, y).Y = Integer.Parse(s)
                Next x
            Next y

            'num = 0
            's = sr.ReadLine()
            'parts = Split(s, delimiter, -1, CompareMethod.Text)
            For y = 0 To iMapDatY - 1
                For x = 0 To iMapDatX - 1
                    'iMatDat_U(x, y).X = Integer.Parse(parts(num))
                    'iMatDat_U(x, y).Y = Integer.Parse(parts(num + 1))
                    'num = num + 2
                    s = sr.ReadLine()
                    iMatDat_U(x, y).X = Integer.Parse(s)
                    s = sr.ReadLine()
                    iMatDat_U(x, y).Y = Integer.Parse(s)
                Next x
            Next y

            'num = 0
            's = sr.ReadLine()
            'parts = Split(s, delimiter, -1, CompareMethod.Text)
            For y = 0 To iMapDatY - 1
                For x = 0 To iMapDatX - 1
                    'iEvID(x, y) = Integer.Parse(parts(num))
                    'num = num + 1
                    s = sr.ReadLine()
                    iEvID(x, y) = Integer.Parse(s)
                Next x
            Next y


            For y = 0 To iMapDatY - 1
                For x = 0 To iMapDatX - 1
                    'iEvID(x, y) = Integer.Parse(parts(num))
                    'num = num + 1
                    s = sr.ReadLine()
                    iマップキャラID(x, y) = Integer.Parse(s)
                Next x
            Next y

            '閉じる
            sr.Close()

            picMapWindow.Invalidate()
            statusLabel.Text = "ファイル読み込みが完了しました。"
        End If
    End Sub
    Public Sub LoadChipData(sFileName)

        statusLabel.Text = "ファイルを読み込み中・・・"

        For k = 0 To iChipMax - 1
            sCurrentChipDir = sFileName
            Dim sr As New System.IO.StreamReader(sCurrentChipDir & k & ".txt", System.Text.Encoding.GetEncoding("UTF-8"))
            Dim s As String

            Dim num As Integer
            Dim delimiter As String = ","
            Dim parts As String()

            '１行読み込む
            's = sr.ReadLine()
            'parts = Split(s, delimiter, -1, CompareMethod.Text)
            For y = 0 To CHIPDATMAX_Y - 1
                For x = 0 To CHIPDATMAX_X - 1
                    'iChipDat(x, y) = Integer.Parse(parts(num))
                    'num = num + 1
                    s = sr.ReadLine()
                    iChipDat(k, x, y) = Integer.Parse(s)
                Next x
            Next y


            '閉じる
            sr.Close()


            imgTemp(k) = Image.FromFile(sCurrentChipDir & k & ".png")
        Next k

        statusLabel.Text = "ファイル読み込みが完了しました。"

    End Sub

    Public Sub Loadキャラデータ()

        Dim sr As New System.IO.StreamReader("chara\\キャラのデータ.txt", System.Text.Encoding.GetEncoding("UTF-8"))

        Dim i As Integer
        Dim str As String
        str = sr.ReadLine()
        最大キャラ数 = Integer.Parse(str)

        ReDim キャラ画像ステータス(最大キャラ数)

        Dim b画像ロード成功 As Boolean
        For i = 0 To 最大キャラ数 - 1
            'ID
            str = sr.ReadLine()

            'GDI_ID
            str = sr.ReadLine()
            キャラ画像ステータス(i).GDI_ID = Integer.Parse(str)

            'ファイル名
            str = sr.ReadLine()

            If System.IO.File.Exists("chara\\" & str) Then
                キャラ画像ステータス(i).Path = str
                キャラ画像ステータス(i).画像 = Image.FromFile("chara\\" & str)
                b画像ロード成功 = True
            Else
                b画像ロード成功 = False
            End If

            'width
            str = sr.ReadLine()
            キャラ画像ステータス(i).サイズ.X = Integer.Parse(str)

            'height
            str = sr.ReadLine()
            キャラ画像ステータス(i).サイズ.Y = Integer.Parse(str)


            'cx
            str = sr.ReadLine()
            キャラ画像ステータス(i).cxcy.X = Integer.Parse(str)
            'cy
            str = sr.ReadLine()
            キャラ画像ステータス(i).cxcy.Y = Integer.Parse(str)

            'iHitOffsetW
            str = sr.ReadLine()
            キャラ画像ステータス(i).iHitOffsetW = Integer.Parse(str)
            'iHitOffsetH
            str = sr.ReadLine()
            キャラ画像ステータス(i).iHitOffsetH = Integer.Parse(str)

            str = sr.ReadLine()
            キャラ画像ステータス(i).AI = Integer.Parse(str)
            str = sr.ReadLine()
            キャラ画像ステータス(i).MHP = Integer.Parse(str)
            str = sr.ReadLine()
            キャラ画像ステータス(i).iEnemDeadAmin = Integer.Parse(str)

            str = sr.ReadLine()
            キャラ画像ステータス(i).bEnemy = Boolean.Parse(str)
            str = sr.ReadLine()
            キャラ画像ステータス(i).bLandingAble = Boolean.Parse(str)
            str = sr.ReadLine()
            キャラ画像ステータス(i).bNoGravity = Boolean.Parse(str)
            str = sr.ReadLine()
            キャラ画像ステータス(i).bThroughWall = Boolean.Parse(str)
            str = sr.ReadLine()
            キャラ画像ステータス(i).bHitableOnlyMap = Boolean.Parse(str)
            str = sr.ReadLine()
            キャラ画像ステータス(i).throughOK = Boolean.Parse(str)
            str = sr.ReadLine()
            キャラ画像ステータス(i).bRideOK = Boolean.Parse(str)


            If Not b画像ロード成功 Then
                i = i - 1
                最大キャラ数 = 最大キャラ数 - 1
            End If
            If i >= 最大キャラ数 - 1 Then 'Basicはfor文の回数を変更できないためここでexit
                Exit For
            End If
        Next i

        '閉じる
        sr.Close()



        'いっぽう、全pngファイルを取得
        Dim di As New System.IO.DirectoryInfo("chara\\")
        Dim files As System.IO.FileInfo() =
        di.GetFiles("*.png", System.IO.SearchOption.AllDirectories)

        Dim キャラ画像数 As Integer = 0
        For Each f As System.IO.FileInfo In files
            キャラ画像数 = キャラ画像数 + 1
            'ListBox1.Items.Add(f.FullName)
        Next f

        If キャラ画像数 > 最大キャラ数 Then
            ReDim Preserve キャラ画像ステータス(キャラ画像数)

            Dim j As Integer
            Dim b一致 As Boolean
            For i = 最大キャラ数 To キャラ画像数 - 1
                For Each f As System.IO.FileInfo In files
                    b一致 = False
                    For j = 0 To 最大キャラ数 - 1
                        If f.Name = キャラ画像ステータス(j).Path Then
                            b一致 = True
                        End If
                    Next j

                    If Not b一致 Then
                        キャラ画像ステータス(i).Path = f.Name
                        キャラ画像ステータス(i).画像 = Image.FromFile("chara\\" & f.Name)
                        キャラ画像ステータス(i).サイズ.X = 32
                        キャラ画像ステータス(i).サイズ.Y = 32
                    End If
                Next f
            Next i


            最大キャラ数 = キャラ画像数
        End If

    End Sub

    Private Sub 開くToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 開くToolStripMenuItem.Click
        LoadMapData()
        LoadChipData(sCurrentChipDir)
        'imgTemp(1) = Image.FromFile("chip\\chip0.png")
    End Sub

    Private Sub btnScaleMode0_Click(sender As Object, e As EventArgs) Handles btnScaleMode0.Click
        iScaleMode = 0
        Dim svX As Integer
        Dim svY As Integer
        スケール変更時のビュー位置修正１(svX, svY)

        lblScaleMode.Left = btnScaleMode0.Left
        fMapScale = 2
        fixScrollBarSize()

        スケール変更時のビュー位置修正２(svX, svY)
        picMapWindow.Invalidate()
    End Sub

    Private Sub btnScaleMode1_Click(sender As Object, e As EventArgs) Handles btnScaleMode1.Click
        iScaleMode = 1
        Dim svX As Integer
        Dim svY As Integer
        スケール変更時のビュー位置修正１(svX, svY)

        lblScaleMode.Left = btnScaleMode1.Left
        fMapScale = 1
        fixScrollBarSize()

        スケール変更時のビュー位置修正２(svX, svY)
        picMapWindow.Invalidate()
    End Sub

    Private Sub btnScaleMode2_Click(sender As Object, e As EventArgs) Handles btnScaleMode2.Click
        iScaleMode = 2
        Dim svX As Integer
        Dim svY As Integer
        スケール変更時のビュー位置修正１(svX, svY)

        lblScaleMode.Left = btnScaleMode2.Left
        fMapScale = 0.5
        fixScrollBarSize()

        スケール変更時のビュー位置修正２(svX, svY)
        picMapWindow.Invalidate()
    End Sub

    Private Sub btnScaleMode3_Click(sender As Object, e As EventArgs) Handles btnScaleMode3.Click
        iScaleMode = 3
        Dim svX As Integer
        Dim svY As Integer
        スケール変更時のビュー位置修正１(svX, svY)

        lblScaleMode.Left = btnScaleMode3.Left
        fMapScale = 0.25
        fixScrollBarSize()

        スケール変更時のビュー位置修正２(svX, svY)
        picMapWindow.Invalidate()
    End Sub
    Private Sub スケール変更時のビュー位置修正１(ByRef svX As Integer, ByRef svY As Integer)
        Dim halfW As Integer = picMapWindow.Width / 2
        Dim halfH As Integer = picMapWindow.Height / 2
        svX = (picMapWinScroll_H.Value + halfW) / fMapScale
        svY = (picMapWinScroll_V.Value + halfH) / fMapScale
    End Sub
    Private Sub スケール変更時のビュー位置修正２(svX As Integer, svY As Integer)
        Dim tx = svX * fMapScale - picMapWindow.Width / 2
        If tx > picMapWinScroll_H.Maximum Then
            tx = picMapWinScroll_H.Maximum
        ElseIf tx < 0 Then
            tx = 0
        End If
        picMapWinScroll_H.Value = tx
        Dim ty = svY * fMapScale - picMapWindow.Height / 2
        If ty > picMapWinScroll_V.Maximum Then
            ty = picMapWinScroll_V.Maximum
        ElseIf ty < 0 Then
            ty = 0
        End If
        picMapWinScroll_V.Value = ty
    End Sub
    Private Sub マップサイズ変更ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles マップサイズ変更ToolStripMenuItem.Click

        '現状のデータを退避(fixBuffSizeをDim preserveでうまくいかないため（ファイルロード時エラー））
        Dim iMapDatX保存 As Integer = iMapDatX
        Dim iMapDatY保存 As Integer = iMapDatY
        Dim iMatDat保存(iMapDatX, iMapDatY) As Point
        Dim iMatDat_U保存(iMapDatX, iMapDatY) As Point
        Dim iEvID保存(iMapDatX, iMapDatY) As Integer
        Dim iマップキャラID保存(iMapDatX, iMapDatY) As Integer
        '現状のデータを退避
        For y = 0 To iMapDatY保存 - 1
            For x = 0 To iMapDatX保存 - 1
                iMatDat保存(x, y).X = iMatDat(x, y).X
                iMatDat保存(x, y).Y = iMatDat(x, y).Y
                iMatDat_U保存(x, y).X = iMatDat_U(x, y).X
                iMatDat_U保存(x, y).Y = iMatDat_U(x, y).Y
                iEvID保存(x, y) = iEvID(x, y)
                iマップキャラID保存(x, y) = iマップキャラID(x, y)
            Next x
        Next y

        Dim sTmp As String
        Dim x_prev As Integer = iMapDatX
        sTmp = InputBox("マップサイズ　X軸を入力してください", “マップサイズ”, iMapDatX, 0, 0)
        If sTmp = "" Then
            Exit Sub
        Else
            iMapDatX = Integer.Parse(sTmp)
        End If

        sTmp = InputBox("マップサイズ　Y軸を入力してください", “マップサイズ”, iMapDatY, 0, 0)
        If sTmp = "" Then
            iMapDatX = x_prev 'X前画面の変更をなかったことにする
            Exit Sub
        Else
            iMapDatY = Integer.Parse(sTmp)
        End If

        '配列サイズを変更
        fixBuffSize()


        '退避したデータを
        For y = 0 To Math.Min(iMapDatY保存, iMapDatY) - 1
            For x = 0 To Math.Min(iMapDatX保存, iMapDatX) - 1
                iMatDat(x, y).X = iMatDat保存(x, y).X
                iMatDat(x, y).Y = iMatDat保存(x, y).Y
                iMatDat_U(x, y).X = iMatDat_U保存(x, y).X
                iMatDat_U(x, y).Y = iMatDat_U保存(x, y).Y
                iEvID(x, y) = iEvID保存(x, y)
                iマップキャラID(x, y) = iマップキャラID保存(x, y)
            Next x
        Next y


        picMapWindow.Invalidate()
    End Sub

    Private Sub チップセット編集ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles チップセット編集ToolStripMenuItem.Click
        'Form2クラスのインスタンスを作成する
        Dim f As New formChipEdit()
        'Form2を表示する
        'ここではモーダルダイアログボックスとして表示する
        'オーナーウィンドウにMeを指定する
        f.ShowDialog(Me)
        'フォームが必要なくなったところで、Disposeを呼び出す
        f.Dispose()
    End Sub

    Private Sub FinaleToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles FinaleToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub 名前を付けて保存ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 名前を付けて保存ToolStripMenuItem.Click

        'OpenFileDialogクラスのインスタンスを作成
        Dim ofd As New SaveFileDialog()

        'はじめのファイル名を指定する
        'はじめに「ファイル名」で表示される文字列を指定する
        ofd.FileName = sCurrentFile '"default.txt"
        'はじめに表示されるフォルダを指定する
        '指定しない（空の文字列）の時は、現在のディレクトリが表示される
        ofd.InitialDirectory = System.Environment.CurrentDirectory & "\map\"
        '[ファイルの種類]に表示される選択肢を指定する
        '指定しないとすべてのファイルが表示される
        ofd.Filter = "テキストファイル(*.txt)|*.txt|すべてのファイル(*.*)|*.*"
        '[ファイルの種類]ではじめに選択されるものを指定する
        '2番目の「すべてのファイル」が選択されているようにする
        ofd.FilterIndex = 1
        'タイトルを設定する
        ofd.Title = "マップファイルを保存"
        'ダイアログボックスを閉じる前に現在のディレクトリを復元するようにする
        ofd.RestoreDirectory = True

        'ダイアログを表示する
        If ofd.ShowDialog() = DialogResult.OK Then
            'OKボタンがクリックされたとき、選択されたファイル名を表示する
            sCurrentFile = ofd.FileName

            saveFiles()
        End If
    End Sub

    Private Sub 全体シフトToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 全体シフトToolStripMenuItem.Click
        Dim iShiftX As Integer
        Dim iShiftY As Integer
        Dim sTmp As String
        'X方向
        sTmp = InputBox("X方向のシフト数", “全体シフト”, 0, 0, 0)
        If sTmp = "" Then
            Exit Sub
        Else
            iShiftX = Integer.Parse(sTmp)
        End If

        'Y方向
        sTmp = InputBox("Y方向のシフト数", “全体シフト”, 0, 0, 0)
        If sTmp = "" Then
            Exit Sub
        Else
            iShiftY = Integer.Parse(sTmp)
        End If


        Dim x As Integer
        Dim y As Integer
        Dim iMapDatX保存 As Integer = iMapDatX
        Dim iMapDatY保存 As Integer = iMapDatY
        Dim iMatDat保存(iMapDatX, iMapDatY) As Point
        Dim iMatDat_U保存(iMapDatX, iMapDatY) As Point
        Dim iEvID保存(iMapDatX, iMapDatY) As Integer
        Dim iマップキャラID保存(iMapDatX, iMapDatY) As Integer
        Dim t As Integer


        'X方向---
        If iShiftX <> 0 Then
            '現状のデータを退避
            For y = 0 To iMapDatY保存 - 1
                For x = 0 To iMapDatX保存 - 1
                    iMatDat保存(x, y).X = iMatDat(x, y).X
                    iMatDat保存(x, y).Y = iMatDat(x, y).Y
                    iMatDat_U保存(x, y).X = iMatDat_U(x, y).X
                    iMatDat_U保存(x, y).Y = iMatDat_U(x, y).Y
                    iEvID保存(x, y) = iEvID(x, y)
                    iマップキャラID保存(x, y) = iマップキャラID(x, y)
                Next x
            Next y
            For y = 0 To iMapDatY - 1
                For x = 0 To iMapDatX - 1
                    t = x - iShiftX
                    If t < 0 Then
                        t = 0
                    ElseIf t >= iMapDatX - 1 Then
                        t = iMapDatX - 1
                    End If
                    iMatDat(x, y).X = iMatDat保存(t, y).X
                    iMatDat(x, y).Y = iMatDat保存(t, y).Y
                    iMatDat_U(x, y).X = iMatDat_U保存(t, y).X
                    iMatDat_U(x, y).Y = iMatDat_U保存(t, y).Y
                    iEvID(x, y) = iEvID保存(t, y)
                    iマップキャラID(x, y) = iマップキャラID保存(t, y)
                Next x
            Next y
        End If


        'Y方向---
        If iShiftY <> 0 Then
            '現状のデータを退避
            For y = 0 To iMapDatY保存 - 1
                For x = 0 To iMapDatX保存 - 1
                    iMatDat保存(x, y).X = iMatDat(x, y).X
                    iMatDat保存(x, y).Y = iMatDat(x, y).Y
                    iMatDat_U保存(x, y).X = iMatDat_U(x, y).X
                    iMatDat_U保存(x, y).Y = iMatDat_U(x, y).Y
                    iEvID保存(x, y) = iEvID(x, y)
                    iマップキャラID保存(x, y) = iマップキャラID(x, y)
                Next x
            Next y
            For y = 0 To iMapDatY - 1
                For x = 0 To iMapDatX - 1
                    t = y - iShiftY
                    If t < 0 Then
                        t = 0
                    ElseIf t >= iMapDatY - 1 Then
                        t = iMapDatY - 1
                    End If
                    iMatDat(x, y).X = iMatDat保存(x, t).X
                    iMatDat(x, y).Y = iMatDat保存(x, t).Y
                    iMatDat_U(x, y).X = iMatDat_U保存(x, t).X
                    iMatDat_U(x, y).Y = iMatDat_U保存(x, t).Y
                    iEvID(x, y) = iEvID保存(x, t)
                    iマップキャラID(x, y) = iマップキャラID保存(x, t)
                Next x
            Next y
        End If

        write_iMatDatBuff()
        picMapWindow.Invalidate()
    End Sub

    Private Sub タイルToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles タイルToolStripMenuItem.Click
        Dim 最大横幅 As Integer
        Dim 最大縦幅 As Integer
        Dim sTmp As String
        'X方向
        sTmp = InputBox("最大横幅（X軸）", “タイル”, iMapDatX, 0, 0)
        If sTmp = "" Then
            Exit Sub
        Else
            最大横幅 = Integer.Parse(sTmp)
        End If

        'Y方向
        sTmp = InputBox("最大縦幅（Y軸）", “タイル”, iMapDatY, 0, 0)
        If sTmp = "" Then
            Exit Sub
        Else
            最大縦幅 = Integer.Parse(sTmp)
        End If

        Dim x As Integer
        Dim y As Integer
        Dim iMapDatX保存 As Integer = iMapDatX
        Dim iMapDatY保存 As Integer = iMapDatY
        Dim iMatDat保存(iMapDatX, iMapDatY) As Point
        Dim iMatDat_U保存(iMapDatX, iMapDatY) As Point
        Dim iEvID保存(iMapDatX, iMapDatY) As Integer
        Dim iマップキャラID保存(iMapDatX, iMapDatY) As Integer
        Dim t As Integer


        If 最大横幅 <> 0 And 最大縦幅 Then
            '現状のデータを退避
            For y = 0 To iMapDatY保存 - 1
                For x = 0 To iMapDatX保存 - 1
                    iMatDat保存(x, y).X = iMatDat(x, y).X
                    iMatDat保存(x, y).Y = iMatDat(x, y).Y
                    iMatDat_U保存(x, y).X = iMatDat_U(x, y).X
                    iMatDat_U保存(x, y).Y = iMatDat_U(x, y).Y
                    iEvID保存(x, y) = iEvID(x, y)
                    iマップキャラID保存(x, y) = iEvID(x, y)
                Next x
            Next y

            iMapDatX = 最大横幅
            iMapDatY = 最大縦幅
            fixBuffSize()

            Dim tx As Integer = 0
            Dim ty As Integer = 0
            For y = 0 To iMapDatY - 1
                For x = 0 To iMapDatX - 1
                    iMatDat(x, y).X = iMatDat保存(tx, ty).X
                    iMatDat(x, y).Y = iMatDat保存(tx, ty).Y
                    iMatDat_U(x, y).X = iMatDat_U保存(tx, ty).X
                    iMatDat_U(x, y).Y = iMatDat_U保存(tx, ty).Y
                    iEvID(x, y) = iEvID保存(tx, ty)
                    iマップキャラID(x, y) = iマップキャラID保存(tx, ty)

                    If tx >= iMapDatX保存 - 1 Then
                        tx = 0
                    Else
                        tx = tx + 1
                    End If
                Next x

                If ty >= iMapDatY保存 - 1 Then
                    ty = 0
                Else
                    ty = ty + 1
                End If
            Next y

        End If


        write_iMatDatBuff()
        picMapWindow.Invalidate()
    End Sub
    Private Sub 落とし穴一括ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 落とし穴一括ToolStripMenuItem.Click
        Dim x As Integer
        Dim y As Integer
        For y = iMapDatY - 2 To iMapDatY - 1
            For x = 0 To iMapDatX - 1
                iEvID(x, y) = 1
            Next x
        Next y

        write_iMatDatBuff()
        picMapWindow.Invalidate()
    End Sub

    Private Sub キャラデータ編集ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles キャラデータ編集ToolStripMenuItem.Click

        'Form2クラスのインスタンスを作成する
        Dim f As New formCharaEdit()
        'Form2を表示する
        'ここではモーダルダイアログボックスとして表示する
        'オーナーウィンドウにMeを指定する
        f.ShowDialog(Me)
        'フォームが必要なくなったところで、Disposeを呼び出す
        f.Dispose()
    End Sub

    Private Sub Form1_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown

        If (e.Modifiers And Keys.Control) = Keys.Control Then
            If e.KeyCode = Keys.Z Then
                Read_iMatDatBuff(-1)
            ElseIf e.KeyData = Keys.Y Then
                Read_iMatDatBuff(+1)
            End If
        End If
    End Sub
End Class
