﻿Imports System.IO

Public Class formCharaEdit
    Private Sub formCharaEdit_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        fixリストボックス()
    End Sub
    Private Sub fixリストボックス()
        ListBox1.Items.Clear()

        Dim i As Integer
        For i = 0 To Form1.最大キャラ数 - 1
            ListBox1.Items.Add((i.ToString).PadLeft(3) & " ： " & Form1.キャラ画像ステータス(i).Path)
        Next i

        ListBox1.SelectedIndex = 0
    End Sub


    Private Sub PictureBox1_Paint(sender As Object, e As PaintEventArgs) Handles PictureBox1.Paint
        Dim width As Integer
        Dim height As Integer

        If ListBox1.SelectedIndex < 0 Then
            Return
        Else
            Dim NUM As Integer
            NUM = ListBox1.SelectedIndex
            width = Form1.キャラ画像ステータス(NUM).画像.Width
            height = Form1.キャラ画像ステータス(NUM).画像.Height
            Dim fScale = 1

            '切り取る部分の範囲を決定する。
            Dim srcRect As New Rectangle(0, 0, width, height)
            '描画する部分の範囲を決定する。
            Dim desRect As New Rectangle(0, 0, width * fScale, height * fScale)
            '画像の一部を描画する
            'g.DrawImage(img, desRect, srcRect, GraphicsUnit.Pixel)
            e.Graphics.DrawImage(Form1.キャラ画像ステータス(NUM).画像, desRect, srcRect, GraphicsUnit.Pixel)


            '---width,heightで囲む
            Dim tx As Integer = 0
            Dim ty As Integer = 0

            Dim p As New Pen(Color.Red, 2)
            Dim q As New Pen(Color.Blue, 2)

            Dim tWidth = Form1.キャラ画像ステータス(NUM).サイズ.X
            Dim tHeight = Form1.キャラ画像ステータス(NUM).サイズ.Y
            Dim tLeft = 0 * tWidth
            Dim tTop = 0 * tHeight

            e.Graphics.DrawRectangle(p, tLeft, tTop, tWidth, tHeight)
            e.Graphics.DrawRectangle(q, tLeft + 2, tTop + 2, tWidth, tHeight)
            p.Dispose()
            q.Dispose()

        End If
    End Sub
    Private Sub PictureBox2_Paint(sender As Object, e As PaintEventArgs) Handles PictureBox2.Paint

        If ListBox1.SelectedIndex < 0 Then
            Return
        Else
            Dim NUM As Integer = ListBox1.SelectedIndex
            Dim width As Integer = Form1.キャラ画像ステータス(NUM).サイズ.X
            Dim height As Integer = Form1.キャラ画像ステータス(NUM).サイズ.Y
            Dim fScale = 2.0


            PictureBox2.Width = width * 2 + 4
            If PictureBox2.Width > 144 Then
                PictureBox2.Width = 144
            End If

            PictureBox2.Height = height * 2 + 4
            If PictureBox2.Height > 144 Then
                PictureBox2.Height = 144
            End If

            '切り取る部分の範囲を決定する。
            Dim srcRect As New Rectangle(0, 0, width, height)
            '描画する部分の範囲を決定する。
            Dim desRect As New Rectangle(0, 0, width * fScale, height * fScale)
            '画像の一部を描画する
            'g.DrawImage(img, desRect, srcRect, GraphicsUnit.Pixel)
            e.Graphics.DrawImage(Form1.キャラ画像ステータス(NUM).画像, desRect, srcRect, GraphicsUnit.Pixel)


            '---iHitOffsetW,iHitOffsetHで囲む
            Dim tx As Integer = 0
            Dim ty As Integer = 0

            Dim p As New Pen(Color.Orange, 2)
            Dim q As New Pen(Color.Green, 2)

            Dim tLeft As Integer = Form1.キャラ画像ステータス(NUM).iHitOffsetW * fScale
            Dim tTop As Integer = Form1.キャラ画像ステータス(NUM).iHitOffsetH * fScale
            Dim tWidth As Integer = Form1.キャラ画像ステータス(NUM).サイズ.X * fScale - Form1.キャラ画像ステータス(NUM).iHitOffsetW * fScale * 2
            Dim tHeight As Integer = Form1.キャラ画像ステータス(NUM).サイズ.Y * fScale - Form1.キャラ画像ステータス(NUM).iHitOffsetH * fScale * 2

            e.Graphics.DrawRectangle(p, tLeft, tTop, tWidth, tHeight)
            e.Graphics.DrawRectangle(q, tLeft + 2, tTop + 2, tWidth, tHeight)
            p.Dispose()
            q.Dispose()
        End If
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        fixキャラ画像サイズ()
    End Sub
    Private Sub fixキャラ画像サイズ()
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).GDI_ID = Integer.Parse(GDI_ID.Text)
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).サイズ.X = Integer.Parse(txtCharaWidth.Text)
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).サイズ.Y = Integer.Parse(txtCharaHeight.Text)
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).cxcy.X = Integer.Parse(cx.Text)
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).cxcy.Y = Integer.Parse(cy.Text)
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).iHitOffsetW = Integer.Parse(iHitOffsetW.Text)
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).iHitOffsetH = Integer.Parse(iHitOffsetH.Text)
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).AI = Integer.Parse(AI.Text)
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).MHP = Integer.Parse(HP.Text)
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).iEnemDeadAmin = Integer.Parse(iEnemDeadAmin.Text)
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).bEnemy = bEnemy.Checked
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).bLandingAble = bLandingAble.Checked
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).bNoGravity = bNoGravity.Checked
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).bThroughWall = bThroughWall.Checked
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).bHitableOnlyMap = bHitableOnlyMap.Checked
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).throughOK = throughOK.Checked
        Form1.キャラ画像ステータス(ListBox1.SelectedIndex).bRideOK = bRideOK.Checked

        PictureBox1.Invalidate()
        PictureBox2.Invalidate()
    End Sub
    Private Sub ListBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListBox1.SelectedIndexChanged
        PictureBox1.Invalidate()
        PictureBox2.Invalidate()

        GDI_ID.Text = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).GDI_ID
        txtCharaWidth.Text = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).サイズ.X
        txtCharaHeight.Text = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).サイズ.Y
        cx.Text = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).cxcy.X
        cy.Text = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).cxcy.Y
        iHitOffsetW.Text = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).iHitOffsetW
        iHitOffsetH.Text = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).iHitOffsetH
        AI.Text = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).AI
        HP.Text = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).MHP
        iEnemDeadAmin.Text = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).iEnemDeadAmin
        bEnemy.Checked = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).bEnemy
        bLandingAble.Checked = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).bLandingAble
        bNoGravity.Checked = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).bNoGravity
        bThroughWall.Checked = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).bThroughWall
        bHitableOnlyMap.Checked = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).bHitableOnlyMap
        throughOK.Checked = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).throughOK
        bRideOK.Checked = Form1.キャラ画像ステータス(ListBox1.SelectedIndex).bRideOK
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Dim svIdx = ListBox1.SelectedIndex
        If ListBox1.SelectedIndex > 0 Then
            Form1.swapキャラデータ(ListBox1.SelectedIndex, ListBox1.SelectedIndex - 1)
            fixリストボックス()
            ListBox1.SelectedIndex = svIdx - 1
        End If
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        Dim svIdx = ListBox1.SelectedIndex
        If ListBox1.SelectedIndex < ListBox1.Items.Count - 1 Then
            Form1.swapキャラデータ(ListBox1.SelectedIndex, ListBox1.SelectedIndex + 1)
            fixリストボックス()
            ListBox1.SelectedIndex = svIdx + 1
        End If
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        '敵　歩行系
        AI.Text = 2

        bEnemy.Checked = True
        bLandingAble.Checked = True
        bNoGravity.Checked = False
        bThroughWall.Checked = False
        bHitableOnlyMap.Checked = False
        throughOK.Checked = False
    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        '敵　飛行系
        AI.Text = 3

        bEnemy.Checked = True
        bLandingAble.Checked = False
        bNoGravity.Checked = True
        bThroughWall.Checked = True
        bHitableOnlyMap.Checked = False
        throughOK.Checked = False
    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        'アイテム
        AI.Text = 1040

        bEnemy.Checked = False
        bLandingAble.Checked = False
        bNoGravity.Checked = True
        bThroughWall.Checked = True
        bHitableOnlyMap.Checked = True
        throughOK.Checked = True
    End Sub
End Class