﻿//************************// loadCharaST.js
// キャラのステータスデータベース
// 2023-11-24 Nenga.Kisaragi
//************************

class LOAD_CHARA_ST{
    //*******************
    //CROWN
    //*******************
    SetCharaST(pMode,NUM,ID,x,y) {

	switch(ID){
		case 1://a-pgcn.png
			pMode.chara[NUM].putForFld(2,x,y,0,0);
			pMode.chara[NUM].w = 32;
			pMode.chara[NUM].h = 32;
			pMode.chara[NUM].iHitOffsetW = 6;
			pMode.chara[NUM].iHitOffsetH = 3;
			pMode.chara[NUM].AI.setAI(NUM,0);
			pMode.chara[NUM].MHP = 0; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 0;
			pMode.chara[NUM].bEnemy = false;
			pMode.chara[NUM].bLandingAble = false;
			pMode.chara[NUM].bNoGravity = false;
			pMode.chara[NUM].bThroughWall = false;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].throughOK = false;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].bRideOK = false;
		break;
		case 2://tohru.png
			pMode.chara[NUM].putForFld(20,x,y,0,0);
			pMode.chara[NUM].w = 128;
			pMode.chara[NUM].h = 128;
			pMode.chara[NUM].iHitOffsetW = 57;
			pMode.chara[NUM].iHitOffsetH = 0;
			pMode.chara[NUM].AI.setAI(NUM,4);
			pMode.chara[NUM].MHP = 1; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 133;
			pMode.chara[NUM].bEnemy = true;
			pMode.chara[NUM].bLandingAble = true;
			pMode.chara[NUM].bNoGravity = false;
			pMode.chara[NUM].bThroughWall = false;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].throughOK = false;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].bRideOK = false;
		break;
		case 3://menmen.png
			pMode.chara[NUM].putForFld(23,x,y,0,0);
			pMode.chara[NUM].w = 32;
			pMode.chara[NUM].h = 32;
			pMode.chara[NUM].iHitOffsetW = 7;
			pMode.chara[NUM].iHitOffsetH = 9;
			pMode.chara[NUM].AI.setAI(NUM,3);
			pMode.chara[NUM].MHP = 1; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 132;
			pMode.chara[NUM].bEnemy = true;
			pMode.chara[NUM].bLandingAble = false;
			pMode.chara[NUM].bNoGravity = true;
			pMode.chara[NUM].bThroughWall = true;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].throughOK = false;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].bRideOK = false;
		break;
		case 4://obj001.png
			pMode.chara[NUM].putForFld(13,x,y,0,0);
			pMode.chara[NUM].w = 32;
			pMode.chara[NUM].h = 32;
			pMode.chara[NUM].iHitOffsetW = 1;
			pMode.chara[NUM].iHitOffsetH = 4;
			pMode.chara[NUM].AI.setAI(NUM,1000);
			pMode.chara[NUM].MHP = 1; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 132;
			pMode.chara[NUM].bEnemy = false;
			pMode.chara[NUM].bLandingAble = true;
			pMode.chara[NUM].bNoGravity = true;
			pMode.chara[NUM].bThroughWall = true;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].throughOK = false;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].bRideOK = true;
		break;
		case 5://obj002.png
			pMode.chara[NUM].putForFld(15,x,y,0,0);
			pMode.chara[NUM].w = 32;
			pMode.chara[NUM].h = 32;
			pMode.chara[NUM].iHitOffsetW = 1;
			pMode.chara[NUM].iHitOffsetH = 2;
			pMode.chara[NUM].AI.setAI(NUM,1002);
			pMode.chara[NUM].MHP = 1; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 132;
			pMode.chara[NUM].bEnemy = false;
			pMode.chara[NUM].bLandingAble = false;
			pMode.chara[NUM].bNoGravity = true;
			pMode.chara[NUM].bThroughWall = false;
			pMode.chara[NUM].bHitableOnlyMap = true;
			pMode.chara[NUM].throughOK = false;
			pMode.chara[NUM].bHitableOnlyMap = true;
			pMode.chara[NUM].bRideOK = true;
		break;
		case 6://obj003.png
			pMode.chara[NUM].putForFld(16,x,y,0,0);
			pMode.chara[NUM].w = 32;
			pMode.chara[NUM].h = 32;
			pMode.chara[NUM].iHitOffsetW = 1;
			pMode.chara[NUM].iHitOffsetH = 14;
			pMode.chara[NUM].AI.setAI(NUM,1010);
			pMode.chara[NUM].MHP = 1; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 132;
			pMode.chara[NUM].bEnemy = false;
			pMode.chara[NUM].bLandingAble = false;
			pMode.chara[NUM].bNoGravity = true;
			pMode.chara[NUM].bThroughWall = false;
			pMode.chara[NUM].bHitableOnlyMap = true;
			pMode.chara[NUM].throughOK = false;
			pMode.chara[NUM].bHitableOnlyMap = true;
			pMode.chara[NUM].bRideOK = true;
		break;
		case 7://obj004.png
			pMode.chara[NUM].putForFld(17,x,y,0,0);
			pMode.chara[NUM].w = 32;
			pMode.chara[NUM].h = 32;
			pMode.chara[NUM].iHitOffsetW = 1;
			pMode.chara[NUM].iHitOffsetH = 12;
			pMode.chara[NUM].AI.setAI(NUM,1020);
			pMode.chara[NUM].MHP = 1; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 132;
			pMode.chara[NUM].bEnemy = false;
			pMode.chara[NUM].bLandingAble = true;
			pMode.chara[NUM].bNoGravity = true;
			pMode.chara[NUM].bThroughWall = false;
			pMode.chara[NUM].bHitableOnlyMap = true;
			pMode.chara[NUM].throughOK = false;
			pMode.chara[NUM].bHitableOnlyMap = true;
			pMode.chara[NUM].bRideOK = false;
		break;
		case 8://obj005.png
			pMode.chara[NUM].putForFld(19,x,y,0,0);
			pMode.chara[NUM].w = 32;
			pMode.chara[NUM].h = 32;
			pMode.chara[NUM].iHitOffsetW = 2;
			pMode.chara[NUM].iHitOffsetH = 5;
			pMode.chara[NUM].AI.setAI(NUM,1030);
			pMode.chara[NUM].MHP = 1; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 132;
			pMode.chara[NUM].bEnemy = false;
			pMode.chara[NUM].bLandingAble = true;
			pMode.chara[NUM].bNoGravity = true;
			pMode.chara[NUM].bThroughWall = false;
			pMode.chara[NUM].bHitableOnlyMap = true;
			pMode.chara[NUM].throughOK = false;
			pMode.chara[NUM].bHitableOnlyMap = true;
			pMode.chara[NUM].bRideOK = false;
		break;
		case 9://pekatsuu.png
			pMode.chara[NUM].putForFld(18,x,y,0,0);
			pMode.chara[NUM].w = 32;
			pMode.chara[NUM].h = 32;
			pMode.chara[NUM].iHitOffsetW = 8;
			pMode.chara[NUM].iHitOffsetH = 7;
			pMode.chara[NUM].AI.setAI(NUM,2);
			pMode.chara[NUM].MHP = 2; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 132;
			pMode.chara[NUM].bEnemy = true;
			pMode.chara[NUM].bLandingAble = true;
			pMode.chara[NUM].bNoGravity = false;
			pMode.chara[NUM].bThroughWall = false;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].throughOK = false;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].bRideOK = false;
		break;
		case 10://spiritlu.png
			pMode.chara[NUM].putForFld(25,x,y,0,0);
			pMode.chara[NUM].w = 64;
			pMode.chara[NUM].h = 64;
			pMode.chara[NUM].iHitOffsetW = 24;
			pMode.chara[NUM].iHitOffsetH = 16;
			pMode.chara[NUM].AI.setAI(NUM,5);
			pMode.chara[NUM].MHP = 3; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 133;
			pMode.chara[NUM].bEnemy = true;
			pMode.chara[NUM].bLandingAble = true;
			pMode.chara[NUM].bNoGravity = false;
			pMode.chara[NUM].bThroughWall = false;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].throughOK = false;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].bRideOK = false;
		break;
		case 11://obj006.png
			pMode.chara[NUM].putForFld(24,x,y,0,0);
			pMode.chara[NUM].w = 64;
			pMode.chara[NUM].h = 64;
			pMode.chara[NUM].iHitOffsetW = 0;
			pMode.chara[NUM].iHitOffsetH = 0;
			pMode.chara[NUM].AI.setAI(NUM,1050);
			pMode.chara[NUM].MHP = 1; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 132;
			pMode.chara[NUM].bEnemy = false;
			pMode.chara[NUM].bLandingAble = false;
			pMode.chara[NUM].bNoGravity = false;
			pMode.chara[NUM].bThroughWall = false;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].throughOK = true;
			pMode.chara[NUM].bHitableOnlyMap = false;
			pMode.chara[NUM].bRideOK = false;
		break;
		case 12://item000.png
			pMode.chara[NUM].putForFld(50,x,y,0,0);
			pMode.chara[NUM].w = 16;
			pMode.chara[NUM].h = 16;
			pMode.chara[NUM].iHitOffsetW = 1;
			pMode.chara[NUM].iHitOffsetH = 3;
			pMode.chara[NUM].AI.setAI(NUM,1050);
			pMode.chara[NUM].MHP = 0; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 0;
			pMode.chara[NUM].bEnemy = false;
			pMode.chara[NUM].bLandingAble = false;
			pMode.chara[NUM].bNoGravity = true;
			pMode.chara[NUM].bThroughWall = true;
			pMode.chara[NUM].bHitableOnlyMap = true;
			pMode.chara[NUM].throughOK = true;
			pMode.chara[NUM].bHitableOnlyMap = true;
			pMode.chara[NUM].bRideOK = false;
		break;
		case 13://item001.png
			pMode.chara[NUM].putForFld(51,x,y,0,0);
			pMode.chara[NUM].w = 16;
			pMode.chara[NUM].h = 16;
			pMode.chara[NUM].iHitOffsetW = 0;
			pMode.chara[NUM].iHitOffsetH = 4;
			pMode.chara[NUM].AI.setAI(NUM,1040);
			pMode.chara[NUM].MHP = 0; NBtl.chara[NUM].HP=NBtl.chara[NUM].MHP;
			pMode.chara[NUM].cx = 0;
			pMode.chara[NUM].cy = 0;
			pMode.chara[NUM].iEnemDeadAmin = 0;
			pMode.chara[NUM].bEnemy = false;
			pMode.chara[NUM].bLandingAble = false;
			pMode.chara[NUM].bNoGravity = true;
			pMode.chara[NUM].bThroughWall = true;
			pMode.chara[NUM].bHitableOnlyMap = true;
			pMode.chara[NUM].throughOK = true;
			pMode.chara[NUM].bHitableOnlyMap = true;
			pMode.chara[NUM].bRideOK = false;
		break;
		}    }
}

